'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createMeta;
function createMeta() {
  var _ref = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

  var request = _ref.request;
  var success = _ref.success;
  var failure = _ref.failure;

  if (!request || !success || !failure) {
    throw new Error('Missing or invalid action type(s) given to createMeta.');
  }

  var initialState = { isFetching: false, lastUpdated: '', error: false };

  return function () {
    var state = arguments.length <= 0 || arguments[0] === undefined ? initialState : arguments[0];
    var action = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];
    var _action$now = action.now;
    var now = _action$now === undefined ? '' : _action$now;
    var _action$error = action.error;
    var error = _action$error === undefined ? true : _action$error;

    switch (action.type) {
      case request:
        return { isFetching: true, lastUpdated: state.lastUpdated, error: false };
      case success:
        return { isFetching: false, lastUpdated: now, error: false };
      case failure:
        return { isFetching: false, lastUpdated: now, error: error };
      default:
        return state;
    }
  };
}